## Star Realms CCG
## Version 2.3.1
##
## This file contains a list of all valid cards, as well as named
## constants and other miscellaneous data shared by both players.
##
## @author: Matthew Milone

VERSION = "2.3.1"

P1_FILE = "data/Player 1.txt"#"data/Player 1.txt"
P2_FILE = "data/Player 2.txt"#"data/Player 1.txt"
IMAGE_DIR = "resources/card_images/original/"#"resources/card_images/original/"
BASE_IMAGE_DIR = "resources/card_images/vertical/"#"resources/card_images/vertical/"
GUI_IMAGE_DIR = "resources/gui_images/"#"resources/gui_images/"

HAND_SIZE = 5
DECK_SIZE = 40
INITIAL_AUTHORITY = 50
TRADE_ROW_LEN = 8
TRADE_CURVE = [0,0,0,0,1,2,4,8]

C_ENUM = {
    "COST": 0,
    "FACTION": 1,
    "TYPE": 2,
    "COPIES": 3,
    "PRIMARY": 4,
    "ALLY": 5,
    "SCRAP": 6
}

ABILITY_TYPES = ["P", "@", "@@", "@G", "@Y", "@B", "@R", "$"]
TYPE_DICT = {"S": "ship", "B": "base", "H": "hero", "SB": "ship or base", "SBH": "card"}
DEFAULT_DST = {"S": "-", "B": "-", "H": "P"}

CARD_DATA = {
    #Card Name:      (cost, faction, type, copies, primary,                                 ally,                               scrap)
    #Core Set
    "Viper":                (0, "",  "S",   0, ("+C",1)                                     , {}                                , ()                    ),
    "Scout":                (0, "",  "S",   0, ("+T",1)                                     , {}                                , ()                    ),
    "Explorer":             (2, "",  "S",   0, ("+T",2)                                     , {}                                , ("+C",2)              ),
    "Blob Fighter":         (1, "G", "S",   3, ("+C",3)                                     , {"@":("draw",1)}                  , ()                    ),
    "Battle Pod":           (2, "G", "S",   2, ("and",(("+C",4),("scr",(1,"T"))))           , {"@":("+C",2)}                    , ()                    ),
    "Trade Pod":            (2, "G", "S",   3, ("+T",3)                                     , {"@":("+C",2)}                    , ()                    ),
    "Blob Wheel":           (3, "G", "B5",  3, ("+C",1)                                     , {}                                , ("+T",3)              ),
    "Ram":                  (3, "G", "S",   2, ("+C",5)                                     , {"@":("+C",2)}                    , ("+T",3)              ),
    "Blob Destroyer":       (4, "G", "S",   2, ("+C",6)                                     , {"@":("and",(("scr",(1,"T")),("dstr",1)))}, ()            ),
    "The Hive":             (5, "G", "B5",  1, ("+C",3)                                     , {"@":("draw",1)}                  , ()                    ),
    "Battle Blob":          (6, "G", "S",   1, ("+C",8)                                     , {"@":("draw",1)}                  , ("+C",4)              ),
    "Blob Carrier":         (6, "G", "S",   1, ("+C",7)                                     , {"@":("acq",("S","-","D"))}       , ()                    ),
    "Mothership":           (7, "G", "S",   1, ("and",(("+C",6),("draw",1)))                , {"@":("draw",1)}                  , ()                    ),
    "Blob World":           (8, "G", "B7",  1, ("or",(("+C",5),("link",(("played",("G","SBH")),("draw","%"))))), {}               , ()                    ),
    "Imperial Fighter":     (1, "Y", "S",   3, ("and",(("+C",2),("odis",1)))                , {"@":("+C",2)}                    , ()                    ),
    "Corvette":             (2, "Y", "S",   2, ("and",(("+C",1),("draw",1)))                , {"@":("+C",2)}                    , ()                    ),
    "Imperial Frigate":     (3, "Y", "S",   3, ("and",(("+C",4),("odis",1)))                , {"@":("+C",2)}                    , ("draw",1)            ),
    "Survey Ship":          (3, "Y", "S",   3, ("and",(("+T",1),("draw",1)))                , {}                                , ("odis",1)            ),
    "Recycling Station":    (4, "Y", "B4*", 2, ("or",(("+T",1),("cycle",2)))                , {}                                , ()                    ),
    "Space Station":        (4, "Y", "B4*", 2, ("+C",2)                                     , {"@":("+C",2)}                    , ("+T",4)              ),
    "War World":            (5, "Y", "B4*", 1, ("+C",3)                                     , {"@":("+C",4)}                    , ()                    ),
    "Battlecruiser":        (6, "Y", "S",   1, ("and",(("+C",5),("draw",1)))                , {"@":("odis",1)}                  , ("and",(("draw",1),("dstr",1))) ),
    "Royal Redoubt":        (6, "Y", "B6*", 1, ("+C",3)                                     , {"@":("odis",1)}                  , ()                    ),
    "Dreadnaught":          (7, "Y", "S",   1, ("and",(("+C",7),("draw",1)))                , {}                                , ("+C",5)              ),
    "Fleet HQ":             (8, "Y", "B8",  1, ("watch",(("GYBR-","S"),("+C",1)))           , {}                                , ()                    ),
    "Federation Shuttle":   (1, "B", "S",   3, ("+T",2)                                     , {"@":("+A",4)}                    , ()                    ),
    "Cutter":               (2, "B", "S",   3, ("and",(("+A",4),("+T",2)))                  , {"@":("+C",4)}                    , ()                    ),
    "Embassy Yacht":        (3, "B", "S",   2, ("and",(("+A",3),("+T",2),("if",(1,("draw",2))))), {}                            , ()                    ),
    "Trading Post":         (3, "B", "B4*", 2, ("or",(("+A",1),("+T",1)))                   , {}                                , ("+C",3)              ),
    "Barter World":         (4, "B", "B4",  2, ("or",(("+A",2),("+T",2)))                   , {}                                , ("+C",5)              ),
    "Freighter":            (4, "B", "S",   2, ("+T",4)                                     , {"@":("nxt",("S","D"))}           , ()                    ),
    "Defense Center":       (5, "B", "B5*", 1, ("or",(("+A",3),("+C",2)))                   , {"@":("+C",2)}                    , ()                    ),
    "Trade Escort":         (5, "B", "S",   1, ("and",(("+A",4),("+C",4)))                  , {"@":("draw",1)}                  , ()                    ),
    "Flagship":             (6, "B", "S",   1, ("and",(("+C",5),("draw",1)))                , {"@":("+A",5)}                    , ()                    ),
    "Port of Call":         (6, "B", "B6*", 1, ("+T",3)                                     , {}                                , ("and",(("draw",1),("dstr",1))) ),
    "Central Office":       (7, "B", "B6",  1, ("and",(("+T",2),("nxt",("S","D"))))         , {"@":("draw",1)}                  , ()                    ),
    "Command Ship":         (8, "B", "S",   1, ("and",(("+A",4),("+C",5),("draw",2)))       , {"@":("dstr",1)}                  , ()                    ),
    "Trade Bot":            (1, "R", "S",   3, ("and",(("+T",1),("scr",(1,"HD"))))          , {"@":("+C",2)}                    , ()                    ),
    "Missile Bot":          (2, "R", "S",   3, ("and",(("+C",2),("scr",(1,"HD"))))          , {"@":("+C",2)}                    , ()                    ),
    "Battle Station":       (3, "R", "B5*", 2, ()                                           , {}                                , ("+C",5)              ),
    "Supply Bot":           (3, "R", "S",   3, ("and",(("+T",2),("scr",(1,"HD"))))          , {"@":("+C",2)}                    , ()                    ),
    "Patrol Mech":          (4, "R", "S",   2, ("or",(("+T",3),("+C",5)))                   , {"@":("scr",(1,"HD"))}            , ()                    ),
    "Stealth Needle":       (4, "R", "S",   1, ("copy",("S","C",True,False))                , {}                                , ()                    ),
    "Battle Mech":          (5, "R", "S",   1, ("and",(("+C",4),("scr",(1,"HD"))))          , {"@":("draw",1)}                  , ()                    ),
    "Mech World":           (5, "R", "B6*", 1, ("proc","all")                               , {}                                , ()                    ),
    "Junkyard":             (6, "R", "B5*", 1, ("scr",(1,"HD"))                             , {}                                , ()                    ),
    "Missile Mech":         (6, "R", "S",   1, ("and",(("+C",6),("dstr",1)))                , {"@":("draw",1)}                  , ()                    ),
    "Machine Base":         (7, "R", "B6*", 1, ("and",(("draw",1),("scr",(1,"H",True,"GYBR-")))), {}                            , ()                    ),
    "Brain World":          (8, "R", "B6*", 1, ("link",(("scr",(2,"HD")),("draw","%")))     , {}                                , ()                    ),
    #Colony Wars
    "Swarmer":              (1, "G", "S",   3, ("and",(("+C",3),("scr",(1,"T"))))           , {"@":("+C",2)}                    , ()                    ),
    "Stellar Reef":         (2, "G", "B3",  3, ("+T",1)                                     , {}                                , ("+C",3)              ),
    "Predator":             (2, "G", "S",   3, ("+C",4)                                     , {"@":("draw",1)}                  , ()                    ),
    "Cargo Pod":            (3, "G", "S",   3, ("+T",3)                                     , {"@":("+C",3)}                    , ("+C",3)              ),
    "Ravager":              (3, "G", "S",   2, ("and",(("+C",6),("scr",(2,"T"))))           , {}                                , ()                    ),
    "Bioformer":            (4, "G", "B4",  2, ("+C",3)                                     , {}                                , ("+T",3)              ),
    "Parasite":             (5, "G", "S",   1, ("or",(("+C",6),("acq",("SBH",6,"-"))))      , {"@":("draw",1)}                  , ()                    ),
    "Plasma Vent":          (6, "G", "B4",  1, ("and",(("+C",5),("blitz",None)))            , {}                                , ("dstr",1)            ),
    "Moonwurm":             (7, "G", "S",   1, ("and",(("+C",8),("draw",1)))                , {"@":("acq",("SBH",2,"H"))}       , ()                    ),
    "Leviathan":            (8, "G", "S",   1, ("and",(("+C",9),("draw",1),("dstr",1)))     , {"@":("acq",("SBH",3,"H"))}       , ()                    ),
    "Star Barge":           (1, "Y", "S",   3, ("+T",2)                                     , {"@":("and",(("+C",2),("odis",1)))},()                    ),
    "Lancer":               (2, "Y", "S",   3, ("and",(("+C",4),("if",(2,("+C",2)))))       , {"@":("odis",1)}                  , ()                    ),
    "Orbital Platform":     (3, "Y", "B4",  3, ("cycle",1)                                  , {"@":("+C",3)}                    , ()                    ),
    "Falcon":               (3, "Y", "S",   2, ("and",(("+C",2),("draw",1)))                , {}                                , ("odis",1)            ),
    "Command Center":       (4, "Y", "B4*", 2, ("and",(("+T",2),("watch",(("Y","S"),("+C",2))))), {}                            , ()                    ),
    "Gunship":              (4, "Y", "S",   2, ("and",(("+C",5),("odis",1)))                , {}                                , ("+T",4)              ),
    "Aging Battleship":     (5, "Y", "S",   1, ("+C",5)                                     , {"@":("draw",1)}                  , ("and",(("+C",2),("draw",2))) ),
    "Heavy Cruiser":        (5, "Y", "S",   1, ("and",(("+C",4),("draw",1)))                , {"@":("draw",1)}                  , ()                    ),
    "Supply Depot":         (6, "Y", "B5*", 1, ("loop",(("link",(("cdis",(1,False)),("or",(("+T","%2"),("+C","%2"))),True,"%")),2)),{"@":("draw",1)},() ),
    "Imperial Palace":      (7, "Y", "B6*", 1, ("and",(("draw",1),("odis",1)))              , {"@":("+C",4)}                    , ()                    ),
    "Emperor's Dreadnaught":(8, "Y", "S",   1, ("and",(("+C",8),("draw",1),("odis",1),("blitz",None))), {}                      , ()                    ),
    "Solar Skiff":          (1, "B", "S",   3, ("+T",2)                                     , {"@":("draw",1)}                  , ()                    ),
    "Storage Silo":         (2, "B", "B3",  2, ("+A",2)                                     , {"@":("+T",2)}                    , ()                    ),
    "Trade Hauler":         (2, "B", "S",   3, ("+T",3)                                     , {"@":("+A",3)}                    , ()                    ),
    "Patrol Cutter":        (3, "B", "S",   3, ("and",(("+T",2),("+C",3)))                  , {"@":("+A",4)}                    , ()                    ),
    "Central Station":      (4, "B", "B5",  2, ("and",(("+T",2),("if",(4,("and",(("+A",4),("draw",1))))))), {}                  , ()                    ),
    "Frontier Ferry":       (4, "B", "S",   2, ("and",(("+T",3),("+A",4)))                  , {}                                , ("dstr",1)            ),
    "Colony Seed Ship":     (5, "B", "S",   1, ("and",(("+T",3),("+C",3),("+A",3),("blitz",None))), {}                          , ()                    ),
    "Federation Shipyard":  (6, "B", "B6*", 1, ("+T",2)                                     , {"@":("nxt",("SB","D"))}          , ()                    ),
    "Peacekeeper":          (6, "B", "S",   1, ("and",(("+C",6),("+A",6)))                  , {"@":("draw",1)}                  , ()                    ),
    "Loyal Colony":         (7, "B", "B6",  1, ("and",(("+T",3),("+C",3),("+A",3)))         , {}                                , ()                    ),
    "Factory World":        (8, "B", "B6*", 1, ("and",(("+T",3),("nxt",("SB","H"))))        , {}                                , ()                    ),
    "Battle Bot":           (1, "R", "S",   3, ("and",(("+C",2),("scr",(1,"H"))))           , {"@":("+C",2)}                    , ()                    ),
    "Warning Beacon":       (2, "R", "B2*", 3, ("and",(("+C",2),("blitz",None)))            , {}                                , ()                    ),
    "Repair Bot":           (2, "R", "S",   3, ("and",(("+T",2),("scr",(1,"D"))))           , {}                                , ("+C",2)              ),
    "Convoy Bot":           (3, "R", "S",   3, ("and",(("+C",4),("scr",(1,"HD"))))          , {"@":("+C",2)}                    , ()                    ),
    "The Oracle":           (4, "R", "B5*", 1, ("scr",(1,"H"))                              , {"@":("+C",3)}                    , ()                    ),
    "Mining Mech":          (4, "R", "S",   2, ("and",(("+T",3),("scr",(1,"HD"))))          , {"@":("+C",3)}                    , ()                    ),
    "Stealth Tower":        (5, "R", "B5*", 1, ("copy",("B","CO",False,True))               , {}                                , ()                    ),
    "Mech Cruiser":         (5, "R", "S",   1, ("and",(("+C",6),("scr",(1,"HD"))))          , {"@":("dstr",1)}                  , ()                    ),
    "Frontier Station":     (6, "R", "B6*", 1, ("or",(("+T",2),("+C",3)))                   , {}                                , ()                    ),
    "The Wrecker":          (7, "R", "S",   1, ("and",(("+C",6),("scr",(2,"HD"))))          , {"@":("draw",1)}                  , ()                    ),
    "The Incinerator":      (8, "R", "B6*", 1, ("scr",(2,"HD"))                             , {"@":("salv",2)}                  , ()                    ),
    #Crisis: Bases & Battleships
    "Trade Wheel":          (3, "G", "B3",  2, ("+T",1)                                     , {"@":("+C",2)}                    , ()                    ),
    "Obliterator":          (6, "G", "S",   1, ("and",(("+C",7),("if",(3,("+C",6)))))       , {"@":("draw",1)}                  , ()                    ),
    "Fighter Base":         (3, "Y", "B5*", 2, ()                                           , {"@":("odis",1)}                  , ()                    ),
    "Imperial Trader":      (5, "Y", "S",   1, ("and",(("+T",3),("draw",1)))                , {"@":("+C",4)}                    , ()                    ),
    "Trade Raft":           (1, "B", "S",   2, ("+T",1)                                     , {"@":("draw",1)}                  , ("+T",1)              ),
    "Construction Hauler":  (6, "B", "S",   1, ("and",(("+A",3),("+T",2),("draw",1)))       , {"@":("nxt",("B","P"))}           , ()                    ),
    "Defense Bot":          (2, "R", "S",   2, ("and",(("+C",1),("scr",(1,"HD")),("if",(1,("+C",8))))), {}                      , ()                    ),
    "Mega Mech":            (5, "R", "S",   1, ("and",(("+C",6),("rtrn",1)))                , {"@":("draw",1)}                  , ()                    ),
    #Crisis: Fleets & Fortresses
    "Spike Pod":            (1, "G", "S",   2, ("and",(("+C",3),("scr",(2,"T"))))           , {}                                , ("+C",2)              ),
    "Death World":          (7, "G", "B6",  1, ("and",(("+C",4),("link",(("scr",(1,"HD",False,"YBR")),("draw","%"))))), {}      , ()                    ),
    "Cargo Launch":         (1, "Y", "S",   2, ("draw",1)                                   , {}                                , ("+T",1)              ),
    "Star Fortress":        (7, "Y", "B6*", 1, ("and",(("+C",3),("strafe",1)))              , {"@":("strafe",1)}                , ()                    ),
    "Customs Frigate":      (4, "B", "S",   2, ("acq",("S",4,"D"))                          , {"@":("+C",4)}                    , ("draw",1)            ),
    "Capitol World":        (8, "B", "B6*", 1, ("and",(("+A",6),("draw",1)))                , {}                                , ()                    ),
    "Patrol Bot":           (2, "R", "S",   2, ("or",(("+T",2),("+C",4)))                   , {"@":("scr",(1,"HD"))}            , ()                    ),
    "Border Fort":          (4, "R", "B5*", 1, ("and",(("+T",1),("+C",2)))                  , {"@":("scr",(1,"HD"))}            , ()                    ),
    #Year-1 Promos
    "Battle Screecher":     (4, "G", "S",   2, ("and",(("+C",5),("scr",(5,"T"))))           , {"@":("+T",2)}                    , ()                    ),
    "Breeding Site":        (4, "G", "B7",  1, ("if",(5,("+C",5)))                          , {}                                , ()                    ),
    "Battle Barge":         (4, "Y", "S",   2, ("and",(("+C",5),("odis",1),("if",(1,("and",(("+C",3),("rtrn",1))))))), {}       , ()                    ),
    "Starbase Omega":       (4, "Y", "B6",  1, ("if",(5,("draw",1)))                        , {}                                , ()                    ),
    "Starmarket":           (4, "B", "B6",  2, ("if",(5,("or",(("+A",5),("+T",3)))))        , {}                                , ()                    ),
    "Megahauler":           (7, "B", "S",   1, ("and",(("+A",5),("acq",("S","-","D"))))     , {"@":("draw",1)}                  , ()                    ),
    "Fortress Oblivion":    (3, "R", "B4*", 2, ("if",(5,("scr",(1,"HD"))))                  , {}                                , ()                    ),
    "The Ark":              (7, "R", "S",   1, ("and",(("+C",5),("link",(("scr",(2,"HD")),("draw","%"))))), {}                  , ("dstr",1)            ),
    #Miscellaneous
    "Security Craft":       (4, "B", "S",   2, ("and",(("+C",4),("+A",3)))                  , {"@":("+T",3)}                    , ()                    ),
    #Mercenary Cards
    "Merc Cruiser":         (3, "",  "S",   3, ("and",(("+C",5),("adapt",(1,0))))           , {}                                , ()                    ),
    "Mercenary Garrison":   (4, "",  "B5*", 1, (), {"@Y":("+C",2), "@R":("scr",(1,"HD")), "@B":("+A",3), "@G":("scr",(2,"T"))}  , ()                    ),
    "Merc Destroyer":       (4, "",  "S",   1, ("and",(("+C",7),("adapt",(4,1,False))))     , {}                                , ()                    ),
    "Merc Tower":           (5, "",  "B5*", 1, ("and",(("+C",2),("adapt",(1,0))))           , {}                                , ()                    ),
    "Merc Battlecruiser":   (6, "",  "S",   1, ("and",(("+C",6),("draw",1),("adapt",(1,0)))), {}                                , ()                    ),
    "The Colossus":         (9, "",  "S",   1, ("and",(("+C",10),("link",(("adapt",(1,0)),("link",(("inplay",("$","SBH")),("draw","%"))),True,"$")))),{},()),
    #United: Assault
    "Trade Star":           (1, "GY","S",   2, ("+T",2)                                     , {}                                , ("+C",2)              ),
    "Union Stronghold":     (5, "GY","B5",  1, ("+C",3)                                     , {"@G":("scr",(1,"T")), "@Y":("odis",1)}, ()               ),
    "Alliance Transport":   (2, "YB","S",   2, ("+T",2)                                     , {"@Y":("odis",1), "@B":("+A",4)}  , ()                    ),
    "Embassy Base":         (8, "YB","B6",  1, ("and",(("draw",2),("cdis",(1,True))))       , {}                                , ()                    ),
    "Coalition Messenger":  (3, "BR","S",   2, ("+T",2)                                     , {"@":("rcvr",("SBH",5))}          , ()                    ),
    "Lookout Post":         (7, "BR","B6*", 1, ("draw",1)                                   , {}                                , ()                    ),
    "Blob Bot":             (3, "RG","S",   2, ("+C",5)                                     , {"@G":("+T",2), "@R":("scr",(1,"HD"))}, ()                ),
    "Exchange Point":       (6, "RG","B7",  1, ("+C",2)                                     , {"@":("scr",(1,"HDT"))}           , ()                    ),
    #United: Command
    "Assault Pod":          (2, "GY","S",   2, ("+C",3)                                     , {"@":("draw",1)}                  , ()                    ),
    "Union Cluster":        (8, "GY","B8",  1, ("+T",4)                                     , {"@":("draw",1)}                  , ()                    ),
    "Alliance Frigate":     (3, "YB","S",   2, ("+C",4)                                     , {"@Y":("+C",3), "@B":("+A",5)}    , ()                    ),
    "Alliance Landing":     (5, "YB","B5*", 1, ("+T",2)                                     , {"@":("+C",2)}                    , ()                    ),
    "Coalition Freighter":  (4, "BR","S",   2, ("+T",3)                                     , {"@B":("nxt",("S","D")), "@R":("scr",(1,"HD"))}, ()       ),
    "Coalition Fortress":   (6, "BR","B6*", 1, ("+T",2)                                     , {"@":("or",(("+C",2),("+A",3)))}  , ()                    ),
    "Unity Fighter":        (1, "RG","S",   2, ("and",(("+C",3),("scr",(1,"T"))))           , {}                                , ("scr",(1,"HD"))      ),
    "Unity Station":        (7, "RG","B6*", 1, ("and",(("scr",(1,"HD")),("scr",(1,"T"))))   , {"@":("+C",4)}                    , ()                    ),
    #Crisis: Heroes
    "Ram Pilot":            (1, "",  "H",   2, ()                                           , {},       ("and",(("+C",2),("proc","G")))                 ),
    "Blob Overlord":        (2, "",  "H",   1, ()                                           , {},       ("and",(("+C",4),("proc","G")))                 ),
    "Cunning Captain":      (1, "",  "H",   2, ()                                           , {},       ("and",(("odis",1),("proc","Y")))               ),
    "Admiral Rasmusson":    (2, "",  "H",   1, ()                                           , {},       ("and",(("draw",1),("proc","Y")))               ),
    "Special Ops Director": (1, "",  "H",   2, ()                                           , {},       ("and",(("+A",4),("proc","B")))                 ),
    "CEO Torres":           (2, "",  "H",   1, ()                                           , {},       ("and",(("+A",7),("proc","B")))                 ),
    "War Elder":            (1, "",  "H",   2, ()                                           , {},       ("and",(("scr",(1,"H")),("proc","R")))          ),
    "High Priest Lyle":     (2, "",  "H",   1, ()                                           , {},       ("and",(("scr",(1,"HD")),("proc","R")))         ),
    #United: Heroes
    "Screecher":            (3, "",  "H",   2, ("and",(("+C",2),("scr",(1,"T")),("proc","G"))), {},     ("and",(("+C",2),("scr",(1,"T")),("proc","G"))) ),
    "Hive Lord":            (5, "",  "H",   1, ("and",(("+C",5),("scr",("all","T")),("proc","G"))), {}, ("and",(("draw",1),("proc","G")))               ),
    "Commander Klik":       (4, "",  "H",   2, ("and",(("cycle",1),("proc","G")))           , {},       ("and",(("cycle",1),("proc","G")))              ),
    "Commodore Zhang":      (5, "",  "H",   1, ("and",(("+C",4),("odis",1),("proc","Y")))   , {},       ("and",(("draw",1),("proc","Y")))               ),
    "Chairman Haygan":      (3, "",  "H",   2, ("and",(("+A",4),("proc","B")))              , {},       ("and",(("+A",4),("proc","B")))                 ),
    "CEO Shaner":           (5, "",  "H",   1, ("and",(("acq",("SB",3,"D")),("proc","B")))  , {},       ("and",(("draw",1),("proc","B")))               ),
    "Chancellor Hartman":   (4, "",  "H",   2, ("and",(("scr",(1,"HD")),("proc","R")))      , {},       ("and",(("scr",(1,"HD")),("proc","R")))         ),
    "Confessor Morris":     (5, "",  "H",   1, ("and",(("scr",(2,"HD")),("proc","R")))      , {},       ("and",(("draw",1),("proc","R")))               ),
    #Docking Cards
    "Sentinel":             (3, "G", "S",   2, ("and",(("+C",5),("dock",None)))             , {}                                , ()                    ),
    "Imperial Defender":    (3, "Y", "S",   2, ("and",(("+C",1),("draw",1),("dock",None)))  , {}                                , ()                    ),
    "Freight Raft":         (3, "B", "S",   2, ("and",(("+T",2),("+A",4),("dock",None)))    , {}                                , ()                    ),
    "Temple Guardian":      (3, "R", "S",   2, ("and",(("or",(("+T",2),("+C",4))),("dock",None))), {}                           , ()                    ),
##    #Frontiers
##    "Stinger":              (1, "G", "S",   3, "3C||"                       , "@ 3C|"               , "$ 1T"            ),
##    "Blob Miner":           (2, "G", "S",   3, "3T|Scr T|"                  , "|"                   , "$ 2C"            ),
##    "Spike Cluster":        (2, "G", "B3",  2, "2C||"                       , "@ 1T|"               , ()                ),
##    "Crusher":              (3, "G", "S",   2, "6C||"                       , "@ 2T|"               , ()                ),
##    "Burrower":             (3, "G", "S",   2, "5C||"                       , "@ Draw 1|"           , "$ Acq Crd (c<5)" ),
##    "Moonwurm Hatchling":   (4, "G", "S",   2, "3T or Dest Ba||"            , "@ 3C|@@ 3C"          , ()                ),
##    "Nesting Ground":       (4, "G", "B5",  1, "2T||"                       , "@ 4C|"               , ()                ),
##    "Pulverizer":           (5, "G", "S",   1, "Scr T|c(Scr T)C|"           , "@ Draw 1|"           , ()                ),
##    "Blob Alpha":           (6, "G", "S",   1, "10C||"                      , "|"                   , ()                ),
##    "Infested Moon":        (6, "G", "B5",  1, "4C||"                       , "@ Draw 1|@@ Draw 1"  , ()                ),
##    "Hive Queen":           (7, "G", "S",   1, "7C|Draw 1|"                 , "@ 3C|@@ 3C"          , ()                ),
##    "Swarm Cluster":        (8, "G", "B8",  1, "5C||"                       , "@ 3C|@@ 3C"          , ()                ),
##    "Frontier Hawk":        (1, "Y", "S",   3, "3C|Draw 1 & Disc 1|"        , "|"                   , ()                ),
##    "Cargo Craft":          (2, "Y", "S",   3, "2T|Opnt Disc|"              , "@ 4C|"               , ()                ),
##    "Light Cruiser":        (3, "Y", "S",   3, "4C|Opnt Disc|"              , "@ 2C|@@ Draw 1"      , ()                ),
##    "Captured Outpost":     (3, "Y", "B3*", 2, "Draw 1 & Disc 1||"          , "|"                   , ()                ),
##    "Farm Ship":            (4, "Y", "S",   2, "3T|Draw 1 & Disc 1||"       , "|"                   , "$ 4C"            ),
##    "Orbital Gun Platform": (4, "Y", "B4*", 2, "3C||"                       , "|"                   , "$ 3T"            ),
##    "Hammerhead":           (5, "Y", "S",   1, "3C, Draw 1|Opnt Disc|"      , "@ Draw 1 & Disc 1|"  , ()                ),
##    "Jamming Terminal":     (5, "Y", "B6",  1, "2C|Opnt Disc|"              , "|"                   , ()                ),
##    "Warpgate Cruiser":     (6, "Y", "S",   1, "Disc x & 2xC|Draw 1|"       , "@ Draw 1|"           , ()                ),
##    "Siege Fortress":       (7, "Y", "B5*", 1, "5C||"                       , "@ 4C|"               , ()                ),
##    "Imperial Flagship":    (8, "Y", "S",   1, "7C|Draw 2|"                 , "@ Opnt Disc|"        , ()                ),
##    "Frontier Runner":      (1, "B", "S",   3, "2T, 2A||"                   , "|"                   , ()                ),
##    "Orbital Shuttle":      (2, "B", "S",   3, "3T|If n(Ba)>1:|4A, Draw 1"  , "|"                   , ()                ),
##    "Patrol Boat":          (3, "B", "S",   2, "4C, 3A||"                   , "@ 2A|"               , ()                ),
##    "Outland Station":      (3, "B", "B4",  3, "1T or 3A||"                 , "|"                   , ()                ),
##    "Long Hauler":          (4, "B", "S",   2, "3T||"                       , "@ 2T|"               , "$ Nxt Ba -> Dck" ),
##    "Mobile Market":        (4, "B", "B4*", 2, "2T||"                       , "|$ 2A, Draw 1"       , "Reassemble"      ),
##    "Federation Cruiser":   (5, "B", "S",   1, "5C, 4A||"                   , "@ 2C, 2A|"           , ()                ),
##    "Ion Station":          (5, "B", "S5*", 1, "2T||"                       , "@ 1T|@@ 4C, 4A"      , ()                ),
##    "Gateship":             (6, "B", "S",   1, "Acq Sh/Ba -> Dck|(c<7)|"    , "@ 5A|"               , ()                ),
##    "Federation Battleship":(7, "B", "S",   1, "5C, 5A|Draw 1|"             , "@ Dst Ba|"           , "$ 10A"           ),
##    "Transit Nexus":        (8, "B", "B6",  1, "3C, 4T, 5A||"               , "|"                   , ()                ),
##    "Builder Bot":          (1, "R", "S",   3, "1T|Scr D|"                  , "@ 1T|"               , "$ 2C"            ),
##    "Plasma Bot":           (2, "R", "S",   3, "3C|Scr H|"                  , "@ 2C|"               , ()                ),
##    "Integration Port":     (3, "R", "B5*", 2, "1T||"                       , "|"                   , ()                ),
##    "Destroyer Bot":        (3, "R", "S",   3, "5C|Src D|"                  , "|"                   , ()                ),
##    "Repair Mech":          (4, "R", "S",   2, "3T or|Rcvr Ba|"             , "@ Scr H/D|"          , ()                ),
##    "Defense System":       (4, "R", "B5*", 2, "2C||"                       , "@ 2C|"               , ()                ),
##    "Enforcer Mech":        (5, "R", "S",   1, "5C|Scr H/D|"                , "@ Dst Ba|"           , "$ Draw 1"        ),
##    "Conversion Yard":      (6, "R", "B4*", 1, "Scr H & 4C||"               , "|"                   , ()                ),
##    "Reclamation Station":  (6, "R", "B6*", 1, "Scr D||"                    , "|"                   , "$ 3n(Scr H/D)C"  ),
##    "Neural Nexus":         (7, "R", "B6*", 1, "Scr H/D|c(Scr H/D)C|"       , "@ Draw 1|"           , ()                ),
##    "Nanobot Swarm":        (8, "R", "S",   1, "5C|Draw 2|Scr 2 H/D"        , "|"                   , ()                ),
##    #Command Decks
##    "Ranger":               (0,  (), "S",   6, "1T or 2C||"                 , "|"                   , ()                ),
##    "Cluster Scout":        (0,  (), "S",   1, "1T||"                       , "@G 1C|Src T"         , ()                ),
##    "Cluster Viper":        (0,  (), "S",   2, "2C||"                       , "@G 1C|"              , ()                ),
##    "Imperial Scout":       (0,  (), "S",   1, "1T||"                       , "@Y 2C|"              , ()                ),
##    "Imperial Viper":       (0,  (), "S",   2, "1C||"                       , "@Y Disc 1 &|Draw 1"  , ()                ),
##    "Federation Scout":     (0,  (), "S",   2, "1T||"                       , "@B c(Nxt B) -= 1|"   , ()                ),
##    "Escort Viper":         (0,  (), "S",   1, "1C||"                       , "@B 1T|"              , ()                ),
##    "Scout Bot":            (0,  (), "S",   2, "1T||"                       , "@R Rcvr Crd (c<3)|"  , ()                ),
##    "Viper Bot":            (0,  (), "S",   1, "2C||"                       , "@R If Scr H/D:|3C"   , ()                ),
##    "Protopod":             (0,  "G","S",   2, "2T||"                       , "@ 1C|"               , ()                ),
##    "Ripper":               (0,  "G","S",   2, "3C||"                       , "|"                   , ()                ),
##    "Swarmling":            (0,  "G","S",   2, "2C||"                       , "@ 1C| Scr T"         , ()                ),
##    "Imperial Talon":       (0,  "Y","S",   2, "2C||"                       , "@ 2C|"               , ()                ),
##    "Stellar Falcon":       (0,  "Y","S",   2, "2C||"                       , "@ Opnt Disc|"        , ()                ),
##    "Tribute Transport":    (0,  "Y","S",   2, "2T or|Draw 1 $ Disc 1|"     , "|"                   , ()                ),
##    "Cargo Boat":           (0,  "B","S",   2, "2T||"                       , "@ 2A|"               , ()                ),
##    "Diplomatic Shuttle":   (0,  "B","S",   2, "1T or 5A||"                 , "|"                   , ()                ),
##    "Frontier Tug":         (0,  "B","S",   2, "2T||"                       , "@ Nxt Ba -> Dck|& Shfl Dck", ()          ),
##    "Laser Drone":          (0,  "R","S",   2, "2C||"                       , "@ 1C|@@ 2C"          , ()                ),
##    "Salvage Drone":        (0,  "R","S",   2, "1T or|Scr H/D|"             , "|"                   , ()                ),
##    "Welder Drone":         (0,  "R","S",   2, "2T or 2C||"                 , "|"                   , ()                ),
##    "Meganaut":             (8, "GY","S",   1, "7C|Draw 1|"                 , "@ Draw 1|"           , "$ 6C"            ),
##    "Super Freighter":      (8, "YB","S",   1, "4T|Draw 2|"                 , "@ Draw 1|"           , ()                ),
##    "Mech Command Ship":    (8, "BR","S",   1, "Scr x H/D (x<3)|3xA|"       , "@ Draw 1|Dst Ba"     , ()                ),
##    "Mech Wurm":            (8, "RG","S",   1, "Scr x H/D (x<3)|4xC|"       , "@ Draw 1|"           , ()                ),
##    "Super Carrier":        (8, "GB","S",   1, "Acq Sh -> H||"              , "@ Draw 1|"           , ()                ),
##    "Mech Battleship":      (8, "YR","S",   1, "Scr x H/D (x<3)|Draw x & Disc x|", "@ 6C|"          , ()                ),
}